<template>
<v-container>
    <v-card>
        <v-card-title>ออร์เดอร์ทั้งหมด</v-card-title>
        <v-divider></v-divider>
        <v-row style="padding: 10px;">
            <v-col class="text-start">
                <v-btn @click="goHome()" text>
                    <v-icon elevation="2" fab>mdi-arrow-left</v-icon>กลับไปยังหน้า Shop
                </v-btn>
            </v-col>
        </v-row>
        <v-card-text>
            <v-list>
                <v-list-item v-for="order in orders" :key="order.user">
                    <v-list-item-content>
                        <v-list-item-title>รหัสคำสั่งซื้อ: {{ order._id }}</v-list-item-title>
                        <v-list-item-subtitle>สั่งซื้อโดย: {{ order.user }}</v-list-item-subtitle>
                        <v-list-item-subtitle>สถานะ: {{ statusOrder() }}</v-list-item-subtitle>
                        <v-list-item-subtitle>สั่งซื้อเมื่อ: {{ formatDate(order.createdAt) }}</v-list-item-subtitle>
                        <v-list-item-subtitle>ราคา: {{ order.totalPrice }}</v-list-item-subtitle>
                        <v-list-item-subtitle>
                            รายการทั้งหมด:
                            <v-list>
                                <v-list-item v-for="(item, index) in order.items" :key="index">
                                    <v-list-item-content>
                                        <v-img v-if="item.productId.img" :src="item.productId.img" max-height="300" max-width="300" contain></v-img>
                                        <v-list-item-title>เมนู: {{ item.productId.products_name }}</v-list-item-title>
                                        <v-list-item-subtitle>จำนวน: {{ item.quantity }}</v-list-item-subtitle>
                                    </v-list-item-content>
                                </v-list-item>
                            </v-list>
                            <v-divider></v-divider>
                        </v-list-item-subtitle>
                    </v-list-item-content>
                </v-list-item>
            </v-list>
        </v-card-text>
    </v-card>
</v-container>
</template>

<script>
import axios from 'axios';
import Swal from 'sweetalert2';
import Cookies from 'js-cookie';
import {
    jwtDecode
} from "jwt-decode";

export default {
    data() {
        return {
            token: Cookies.get('token'),
            orders: [],
            status_order: "",
            loginId: ''
        };
    },
    created() {
        this.fetchOrders();
        this.getuser();
    },
    methods: {
        async getuser() {
            if (this.token) {
                try {
                    const decoded = jwtDecode(this.token);
                    this.firstName = decoded.firstName;
                    this.loginId = decoded._id;
                    // console.log(this.firstName);
                    // console.log(this.loginId);
                } catch (error) {
                    Swal.fire({
                        position: "center",
                        icon: "error",
                        title: "Session Expired",
                        showConfirmButton: false,
                        timer: 3000
                    });
                    this.$router.push('/Homepage');
                }
            } else {
                Swal.fire({
                    position: "center",
                    icon: "error",
                    title: "Time Out",
                    showConfirmButton: false,
                    timer: 3000
                });
                this.$router.push('/Homepage');
            }
        },
        async fetchOrders() {
            try {
                const response = await axios.get(`http://192.168.73.121:3000/orders/${this.loginId}`, {
                    headers: {
                        Authorization: `Bearer ${this.token}`
                    }
                });
                this.orders = response.data.data;
                console.log(response.data.data);

                // this.orders.forEach((order, index) => {
                //     console.log(`สถานะของออร์เดอร์ที่ ${index + 1}: ${order.status}`);
                // });

                // เรียกใช้ method statusOrder() หลังจากได้รับข้อมูล order เรียบร้อยแล้ว
                const status = this.statusOrder();
                console.log(status);
            } catch (error) {
                console.error('Error fetching orders:', error);
            }
        },
        statusOrder() {
            // ตรวจสอบว่ามี order ในตัวแปร this หรือไม่


            // ตรวจสอบสถานะของ order แรกในรายการ
            // Initialize a variable to store the status messages for each order
            const orderStatuses = this.orders.map(order => {
                if (order.status === 'Success') {
                    return 'ชำระเงินแล้ว'; // 'Payment made'
                } else if (order.status === 'Unsuccess') {
                    return 'ยังไม่มีการชำระเงิน'; // 'No payment made'
                } else {
                    return order.status; // Return the status as is if it's neither 'Success' nor 'Unsuccess'
                }
            });

            // Join the status messages into a single string, if needed
            const allOrderStatuses = orderStatuses.join(', ');

            // Example of returning all order statuses
            return allOrderStatuses;

        },
        formatDate(date) {
            return new Date(date).toLocaleString();
        },
        goHome() {
            this.$router.push('/');
        },
    }
};
</script>
